package pathgame.gameplay.menu;

import pathgame.gameplay.Gamestates;

public class EscMenu extends BaseMenu {
    private final MenuButton[] options;

    public EscMenu(int id, int mainId) {
        super(id);

        options = new MenuButton[]{
            new MenuButton("Continue", (gamestate) -> {
                gamestate.setState(Gamestates.GAMEPLAY);
            }),
            new MenuButton("Retry", (gamestate, level) -> {
                level.reset();
                gamestate.setState(Gamestates.GAMEPLAY);
            }),
            new MenuButton("Main Menu", (gamestate) -> {
                setReturnId(mainId);
            }),
            new MenuButton("Exit", (gamestate) -> {
                gamestate.stop();
            })};
    }

    /**
     * Returns the options of the EscapeMenu
     *
     * @return the options of the EscapeMenu
     */
    @Override
    public MenuButton[] getOptions() {
        return options;
    }
}
