package pathgame.rendering;

public class TileTexture {
    public final static float TEXTURE_SIZE = 512;
    private final static float TILE_TEXTURE_PERCENT = TileRenderer.TILE_SIZE / TEXTURE_SIZE;
    private final static int TILES_PER_LINE = (int) (TEXTURE_SIZE / TileRenderer.TILE_SIZE);

    public static TileTexture fromTextureId(int textureId) {
        float tMinX = (textureId % TILES_PER_LINE) * TILE_TEXTURE_PERCENT;
        float tMinY = (textureId / TILES_PER_LINE) * TILE_TEXTURE_PERCENT;
        float tMaxX = tMinX + TILE_TEXTURE_PERCENT;
        float tMaxY = tMinY + TILE_TEXTURE_PERCENT;
        return new TileTexture(tMinX, tMinY, tMaxX, tMaxY);
    }

    private final float tMinX;
    private final float tMinY;
    private final float tMaxX;
    private final float tMaxY;

    public TileTexture(float tMinX, float tMinY, float tMaxX, float tMaxY) {
        this.tMinX = tMinX;
        this.tMinY = tMinY;
        this.tMaxX = tMaxX;
        this.tMaxY = tMaxY;
    }

    public float getMinX() {
        return tMinX;
    }

    public float getMinY() {
        return tMinY;
    }

    public float getMaxX() {
        return tMaxX;
    }

    public float getMaxY() {
        return tMaxY;
    }
}
